<template>
  <q-card
    flat
    bordered
    class="file-card"
  >
    <q-item>
      <q-item-section>
        <q-item-label>
          {{ getLabel(upload.file) }}
        </q-item-label>
        <q-item-label caption>
          {{ upload.file.fileExtension.toUpperCase() }}, {{ getCaption(upload.file) }}
        </q-item-label>
      </q-item-section>
    </q-item>
    <q-item
      class="items-center justify-center"
      style="height: 200px"
    >
      <q-circular-progress
        v-if="upload.getStatus()==='checking'"
        show-value
        indeterminate
        font-size="20px"
        size="150px"
        :thickness="0.25"
        color="black"
        track-color="grey-3"
        class="q-ma-md"
      >
        <q-icon
          :name="getAnonymizationStatusIcon(upload)"
          size="30px"
        />
      </q-circular-progress>
      <q-circular-progress
        v-else
        show-value
        :value="mainUploadProgess"
        font-size="20px"
        :thickness="0.25"
        color="black"
        size="150px"
        track-color="grey-3"
        class="q-ma-md"
      >
        <div v-if="upload.getStatus()==='queued'">
          <q-icon
            :name="getAnonymizationStatusIcon(upload)"
            size="30px"
          />
        </div>
        <div v-else>
          {{ mainUploadProgess }}%
        </div>
      </q-circular-progress>
    </q-item>
    <q-item class="items-center justify-center">
      <div
        v-if="upload.getStatus()==='checking' || upload.getStatus()==='queued'"
        class="q-pa-sm"
        style="text-align: center"
      >
        {{ upload.getAnonymizationStatus().toUpperCase() }}
      </div>
      <div
        v-else
        class="q-pa-sm"
        style="text-align: center"
      >
        {{ upload.getStatus().toUpperCase() }}
      </div>
    </q-item>
    <q-item
      v-if="upload.getStatus() !== 'queued' && upload.getStatus() !== 'checking'"
      class="items-center justify-center"
    >
      <q-btn
        class="q-ma-sm"
        outline
        :icon="getStatusIcon(upload)"
        @click="pauseOrResumeUpload()"
      >
        <q-tooltip
        anchor="top middle"
        self="bottom middle"
        :offset="[15, 15]">
          Pause or resume upload
        </q-tooltip>
      </q-btn>
      <q-btn
        class="q-ma-sm"
        color="red"
        outline
        icon="cancel"
        @click="cancel()"
      >
        <q-tooltip
        anchor="top middle"
        self="bottom middle"
        :offset="[15, 15]">
          Cancel upload
        </q-tooltip>
      </q-btn>
    </q-item>
    <q-item
      v-if="upload.getStatus() === 'queued'"
      class="items-center justify-center"
    >
      <q-btn
        class="q-ma-sm"
        outline
        :icon="getStatusIcon(upload)"
        @click="startUpload()"
      >
        <q-tooltip
        anchor="top middle"
        self="bottom middle"
        :offset="[15, 15]">
          Start upload
        </q-tooltip>
      </q-btn>
      <q-btn
        class="q-ma-sm"
        color="red"
        outline
        icon="cancel"
        @click="cancel()"
      >
        <q-tooltip
        anchor="top middle"
        self="bottom middle"
        :offset="[15, 15]">
          Cancel upload
        </q-tooltip>
      </q-btn>
    </q-item>
    <upload-agreement
      ref="uploadAgreement"
      @accepted="acceptedAgreement"
      @acceptedRemoval="acceptedRemoval"
    />
  </q-card>
</template>

<script>
import UploadAgreement from './dialogs/UploadAgreement.vue'
import { getLabel } from '../mixins/slides'
import {
  fileStatusIconMapping, getStatusIcon, getAnonymizationStatusIcon
} from '../mixins/uploads'

export default {
  name: 'UploadCard',
  components: {
    uploadAgreement: UploadAgreement
  },
  props: {
    upload: {
      type: Object,
      default: null
    }
  },
  data: function () {
    return {
      mainUploadProgess: 0,
      mainSize: 0
    }
  },
  watch: {
    upload: {
      deep: true,
      handler () {
        this.mainUploadProgess = Math.round(100.0 * this.upload.getProgress())
        this.mainSize = this.upload.getTotalBytes()
      }
    }
  },
  async created () {
    this.mainUploadProgess = Math.round(100.0 * this.upload.getProgress())
    this.mainSize = this.upload.getTotalBytes()
    this.getLabel = getLabel
    this.fileStatusIconMapping = fileStatusIconMapping
    this.getStatusIcon = getStatusIcon
    this.getAnonymizationStatusIcon = getAnonymizationStatusIcon
  },
  methods: {
    acceptedAgreement () {
      this.startUpload(true)
    },
    acceptedRemoval () {
      this.cancel()
    },
    startUpload (acceptedUploadAgreement = false) {
      const anonymizationStatus = this.upload.getAnonymizationStatus()
      if ((anonymizationStatus.includes('failed') || anonymizationStatus.includes('unsupported')) && acceptedUploadAgreement === false) {
        this.$refs.uploadAgreement.agreement = true
        return
      }
      this.$emit('start-upload')
    },
    getCaption (file) {
      const size = Math.round(this.mainSize / 1000000)
      let caption = `${size} MB`
      if (file.linkedFiles.length > 0) {
        caption += `, ${file.linkedFiles.length + 1} files`
      }
      return caption
    },
    pauseOrResumeUpload () {
      if (this.upload.isUploading()) {
        this.upload.pause()
      } else {
        this.upload.resume()
      }
    },
    cancel () {
      this.upload.cancel()
      this.$emit('delete-upload')
    }
  }
}
</script>

<style lang="sass" scoped>
.file-card
  width: 250px
  height: 400px
</style>
